
#include <string>
#include <fstream>
#include <iostream>

#include <support.hh>
#include <os.hh>

#include <inttypes.h>

class ieee1394_module;

std::ostream& operator<< (std::ostream& os, const ieee1394_module& module);

class ieee1394_module {
public:

  std::string module;
  unsigned int match_flags, vendor_id, specifier_id, version;

  bool operator== (const ieee1394_module& other) {


    const int MATCH_VENDOR_ID    = 0x0001;
    const int MATCH_SPECIFIER_ID = 0x0004;
    const int MATCH_VERSION      = 0x0008;

    if (match_flags & MATCH_VENDOR_ID && vendor_id != other.vendor_id)
      return false;

    if (match_flags & MATCH_SPECIFIER_ID && specifier_id != other.specifier_id)
      return false;

    if (match_flags & MATCH_VERSION && version != other.version)
      return false;

    return true;
  };
  
  void read_from_sysfs (const std::string& file) {
    vendor_id = read_value_from_file<uint32_t> (file + "/vendor_id");
    specifier_id = read_value_from_file<uint32_t> (file + "/specifier_id");
    version = read_value_from_file<uint32_t> (file + "/version");
  }

  void read_from_proc (const std::string& file) {
    /*
    std::ifstream f (file.c_str());

    unsigned char cs [64];
    f.read ((char*)cs, sizeof (cs));

    // in machine byte order ... 
    idVendor = *((uint16_t*)&cs[8]);
    idProduct = *((uint16_t*)&cs[10]);

    bcdDevice_lo = cs[14];
    bcdDevice_hi = cs[13];

    bDeviceClass = cs[4];
    bDeviceSubClass = cs[5];
    bDeviceProtocol = cs[6];

    bInterfaceClass = cs[32];
    bInterfaceSubClass = cs[33];
    bInterfaceProtocol = cs[34];

    std::cout << *this << std::endl;
    */
  }
};

std::ostream& operator<< (std::ostream& os, const ieee1394_module& m) {

  os << " Vendor: " << m.vendor_id << ", Specifier: " << m.specifier_id
     << ", Version: " << m.version;

  if (!m.module.empty())
    os << ": Module: " << m.module;

  os << std::endl;
  return os;
}
